#lang at-exp racket
(require infix)
(require plot)

(define r 30)
(define off (+ 5 (* 2 r)))

; algebraic half-cirles
(define (c1 x) @${ sqrt[r^2 - x^2]})
(define (c2 x) @${-sqrt[r^2 - x^2]})

; parametric circle
(define (cp t) @${vector[off + r*cos[t], r*sin[t]]})

(plot (list
       (axes)
       (function c1 (- r) r #:color "blue" #:label "c1" #:width 2)
       (function c2 (- r) r #:color "cyan" #:label "c2" #:style `dot)
       (parametric cp 0 (* 2 pi) #:color "red" #:label "cp"))
      #:x-min (- r)
      #:x-max (+ off r)
      #:y-min (- r)
      #:y-max (+ off r)
      #:legend-anchor 'top-right)
